"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.webAPIMiddleware = webAPIMiddleware;
var _express = _interopRequireWildcard(require("express"));
var _validation = require("../validation");
var _security = require("./security");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function webAPIMiddleware(tokenMiddleware, webEndpointsApi) {
  // eslint-disable-next-line new-cap
  const route = (0, _express.Router)();
  // validate all of these params as a package name
  // this might be too harsh, so ask if it causes trouble=
  route.param('package', _validation.validatePackage);
  route.param('filename', _validation.validateName);
  route.param('version', _validation.validateName);
  route.use(_express.default.urlencoded({
    extended: false
  }));
  route.use(_security.setSecurityWebHeaders);
  if (typeof tokenMiddleware === 'function') {
    route.use(tokenMiddleware);
  }
  if (typeof webEndpointsApi === 'function') {
    route.use(webEndpointsApi);
  }
  return route;
}
//# sourceMappingURL=web-api.js.map